﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Web.UI;

public partial class _Default : RadAjaxPage
{
	bool isFilterClicked = false;
	protected void Page_Load(object sender, EventArgs e)
	{
		EnableGridFilter();

		string controlName = Request.Params.Get("__EVENTTARGET");

		if (!string.IsNullOrEmpty(controlName))
			if (controlName.Equals(HiddenField1.UniqueID))
			{// The postback is triggered by calling the __doPostBack(hField.name, ""); in OnFilterMenuClicking javaScript handler
				isFilterClicked = true;// Yes the filter icon is clicked
			}
	}

	private void EnableGridFilter()
	{
		List<object> filtermenuItems = new List<object>()
		{ // Add only implemented commands
			new {CommandName = GridKnownFunction.NoFilter.ToString()},
			new {CommandName = GridKnownFunction.StartsWith.ToString()},
			new {CommandName = GridKnownFunction.EndsWith.ToString()},
		    new {CommandName = GridKnownFunction.Contains.ToString()}
		};

		RadGrid explorerGrid = RadFileExplorer1.Grid;
		explorerGrid.FilterMenu.OnClientItemClicking = "OnFilterMenuClicking";// Attache the client side handler
		explorerGrid.MasterTableView.AllowFilteringByColumn = true;// Enable filtering 
		// Disable filtering for the size column
		(RadFileExplorer1.Grid.MasterTableView.Columns[1] as GridTemplateColumn).AllowFiltering = false;

		explorerGrid.FilterMenu.DataSource = filtermenuItems;
		explorerGrid.FilterMenu.DataValueField = "CommandName";
		explorerGrid.FilterMenu.DataTextField = "CommandName";
		explorerGrid.FilterMenu.DataBind();
	}

	protected void RadFileExplorer1_ExplorerPopulated(object sender, RadFileExplorerPopulatedEventArgs e)
	{
		string populatedControl = e.ControlName;

		if (populatedControl == "grid")
		{// Grid is populated
			string filterExplression = HiddenField1.Value;// get passed value from the client
			// Split the parameter. (filterExplression looks like this :".jpg{#}EndsWith" 
			string[] filterData = filterExplression.Split(new string[] { "{#}" }, StringSplitOptions.RemoveEmptyEntries);
			
			if (filterData.Length > 1 && isFilterClicked)
			{
				string filterText = filterData[0];// The filter text
				GridKnownFunction gridKnownFunction = (GridKnownFunction)Enum.Parse(typeof(GridKnownFunction), filterData[1]);

				switch (gridKnownFunction)
				{
					case GridKnownFunction.StartsWith:
						{
							e.List = e.List.FindAll(fi => fi.Name.StartsWith(filterText)).ToList();
						}; break;
					case GridKnownFunction.EndsWith:
						{
							e.List = e.List.FindAll(fi => fi.Name.EndsWith(filterText)).ToList();
						}; break;
					case GridKnownFunction.Contains:
						{
							e.List = e.List.FindAll(fi => fi.Name.Contains(filterText)).ToList();
						}; break;
				}
			}
		}
	}
}
